Bug 1889362 - Review Request: python-fastjsonschema - Fastest Python implementation of JSON schema
Summary: Review Request: python-fastjsonschema - Fastest Python implementation of JSON...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1888489
TreeView+ depends on / blocked
 
Reported: 2020-10-19 13:28 UTC by Tomáš Hrnčiar
Modified: 2020-10-26 12:38 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-10-26 12:38:06 UTC
Type: ---
mhroncok: fedora-review+


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-10-19 13:28:03 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/thrnciar/python-fastjsonschema/fedora-rawhide-x86_64/01712197-python-fastjsonschema/python-fastjsonschema.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/thrnciar/python-fastjsonschema/fedora-rawhide-x86_64/01712197-python-fastjsonschema/python-fastjsonschema-2.14.5-1.fc34.src.rpm
Description: 

fastjsonschema implements validation of JSON documents by JSON schema. The library implements JSON schema drafts 04, 06 and 07. The main purpose is to have a really fast implementation. See some numbers:
* Probably most popular jsonschema can take up to 5 seconds for valid inputs and 1.2 seconds for invalid inputs.
* Second most popular json-spec is even worse with up to 7.2 and 1.7 seconds.
* Last validictory, now deprecated, is much better with 370 or 23 milliseconds, but it does not follow all standards and it can be still slow for some purposes.

With this library you can gain big improvements as fastjsonschema takes only about 25 milliseconds for valid inputs and 2 milliseconds for invalid ones.

Fedora Account System Username: thrnciar

Comment 1 Miro Hrončok 2020-10-19 14:26:45 UTC
Spec sanity:

1) You should use %{version} in the Source URL instead of hardcocded values.

2) You could use %{url} in the Source URL to make it shorter (but you don't have to).

3) The description of python3-fastjsonschema could be longer. What about reusing the main description?

4) I find the macro %{srcname} a tad confusing in this context, since the source repo is called python-fastjsonschema. Is strongly suggest to either rename the macro to %{pypi_name} or to replace the macro with the value.

Comment 2 Miro Hrončok 2020-10-19 14:29:03 UTC
Curiosity question:

%pytest -m "not benchmark"

This looks copy-pasted-adapted from tox.ini. Since you use %pyproject_buildrequires -t, I'd consider using %tox directly. Have you tried (and failed)?

Comment 3 Tomáš Hrnčiar 2020-10-20 06:27:34 UTC
(In reply to Miro Hrončok from comment #2)
> Curiosity question:
> 
> %pytest -m "not benchmark"
> 
> This looks copy-pasted-adapted from tox.ini. Since you use
> %pyproject_buildrequires -t, I'd consider using %tox directly. Have you
> tried (and failed)?

Yes, I tried it with %tox, but I almost immidiately told myself that it won't work because I need to somehow disable "benchmarking". Then, I noticed in tox.ini 'pytest -m "not benchmark"' and it seemed like what was I looking for and it worked. I just noticed that building it just with %tox passed in Copr as well.

Comment 5 Miro Hrončok 2020-10-20 10:56:35 UTC
Now %pypi_name is python-fastjsonschema which is also not consistent with reality, because the pypi_name is fastjsonschema. Also, the package name is python3-python-fastjsonschema whch is not what the guidelines suggest.



Consider this:

 - the source repository name is called python-fastjsonschema
 - the pypi package is called fastjsonschema
 - the source package should be named python-fastjsonschema
 - the binary package should be named python3-fastjsonschema

Given the 4 constrains I recommend the following:

 - Drop %srcname, %pypi_name altogether, you don't need them, they don't make the spec easier to read. (I prefer this.)

Or:

 - Define %pypi_name to fastjsonschema, derive the package name from it as usual, careful with Source URL.

Comment 7 Miro Hrončok 2020-10-23 09:01:55 UTC
Package Review
==============


This package is APPROVED.

Pleas fix the typo in %description (reall -> really) and fix that in upstream in case it has been copy pasted from there.









Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-clause "New" or "Revised"
     License".
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-fastjsonschema-2.14.5-1.fc34.noarch.rpm
          python-fastjsonschema-2.14.5-1.fc34.src.rpm
python3-fastjsonschema.noarch: W: spelling-error %description -l en_US reall -> real, recall, really
python-fastjsonschema.src: W: spelling-error %description -l en_US reall -> real, recall, really
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
python3-fastjsonschema.noarch: W: spelling-error %description -l en_US reall -> real, recall, really
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Source checksums
----------------
https://github.com/horejsek/python-fastjsonschema/archive/v2.14.5/python-fastjsonschema-2.14.5.tar.gz :
  CHECKSUM(SHA256) this package     : 0209de91f74db5fa93d67164d594d16af93e63358630bfe99cc2cd3cc7d4a6b2
  CHECKSUM(SHA256) upstream package : 0209de91f74db5fa93d67164d594d16af93e63358630bfe99cc2cd3cc7d4a6b2


Requires
--------
python3-fastjsonschema (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python3-fastjsonschema:
    python-fastjsonschema
    python3-fastjsonschema
    python3.9-fastjsonschema
    python3.9dist(fastjsonschema)
    python3dist(fastjsonschema)



Generated by fedora-review 0.7.0 (fed5495) last change: 2019-03-17
Command line :try-fedora-review -b 1889362 -m fedora-rawhide-x86_64 --mock-options=--enablerepo=local
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, Python
Disabled plugins: SugarActivity, Java, fonts, Ocaml, R, PHP, Perl, Haskell, C/C++, Ruby
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 8 Gwyn Ciesla 2020-10-23 13:16:21 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-fastjsonschema


Note You need to log in before you can comment on or make changes to this bug.